]> git.ipfire.org Git - thirdparty/git.git/blob - t/test-lib.sh
7cc9a52cbf78358e545f27cd5b7f69ac2030ecbf
[thirdparty/git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
23 ;;
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset $(perl -e '
48 my @env = keys %ENV;
49 my @vars = grep(/^GIT_/ && !/^GIT_(TRACE|DEBUG|USE_LOOKUP)/, @env);
50 print join("\n", @vars);
51 ')
52 GIT_AUTHOR_EMAIL=author@example.com
53 GIT_AUTHOR_NAME='A U Thor'
54 GIT_COMMITTER_EMAIL=committer@example.com
55 GIT_COMMITTER_NAME='C O Mitter'
56 GIT_MERGE_VERBOSITY=5
57 export GIT_MERGE_VERBOSITY
58 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
59 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
60 export EDITOR
61
62 # Protect ourselves from common misconfiguration to export
63 # CDPATH into the environment
64 unset CDPATH
65
66 unset GREP_OPTIONS
67
68 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
69 1|2|true)
70 echo "* warning: Some tests will not work if GIT_TRACE" \
71 "is set as to trace on STDERR ! *"
72 echo "* warning: Please set GIT_TRACE to something" \
73 "other than 1, 2 or true ! *"
74 ;;
75 esac
76
77 # Convenience
78 #
79 # A regexp to match 5 and 40 hexdigits
80 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
81 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
82
83 # Each test should start with something like this, after copyright notices:
84 #
85 # test_description='Description of this test...
86 # This test checks if command xyzzy does the right thing...
87 # '
88 # . ./test-lib.sh
89 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
90 TERM=$ORIGINAL_TERM &&
91 export TERM &&
92 [ -t 1 ] &&
93 tput bold >/dev/null 2>&1 &&
94 tput setaf 1 >/dev/null 2>&1 &&
95 tput sgr0 >/dev/null 2>&1
96 ) &&
97 color=t
98
99 while test "$#" -ne 0
100 do
101 case "$1" in
102 -d|--d|--de|--deb|--debu|--debug)
103 debug=t; shift ;;
104 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
105 immediate=t; shift ;;
106 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
107 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
108 -h|--h|--he|--hel|--help)
109 help=t; shift ;;
110 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
111 verbose=t; shift ;;
112 -q|--q|--qu|--qui|--quie|--quiet)
113 # Ignore --quiet under a TAP::Harness. Saying how many tests
114 # passed without the ok/not ok details is always an error.
115 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
116 --with-dashes)
117 with_dashes=t; shift ;;
118 --no-color)
119 color=; shift ;;
120 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
121 valgrind=t; verbose=t; shift ;;
122 --tee)
123 shift ;; # was handled already
124 --root=*)
125 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
126 shift ;;
127 *)
128 echo "error: unknown test option '$1'" >&2; exit 1 ;;
129 esac
130 done
131
132 if test -n "$color"; then
133 say_color () {
134 (
135 TERM=$ORIGINAL_TERM
136 export TERM
137 case "$1" in
138 error) tput bold; tput setaf 1;; # bold red
139 skip) tput bold; tput setaf 2;; # bold green
140 pass) tput setaf 2;; # green
141 info) tput setaf 3;; # brown
142 *) test -n "$quiet" && return;;
143 esac
144 shift
145 printf "%s" "$*"
146 tput sgr0
147 echo
148 )
149 }
150 else
151 say_color() {
152 test -z "$1" && test -n "$quiet" && return
153 shift
154 echo "$*"
155 }
156 fi
157
158 error () {
159 say_color error "error: $*"
160 GIT_EXIT_OK=t
161 exit 1
162 }
163
164 say () {
165 say_color info "$*"
166 }
167
168 test "${test_description}" != "" ||
169 error "Test script did not set test_description."
170
171 if test "$help" = "t"
172 then
173 echo "$test_description"
174 exit 0
175 fi
176
177 exec 5>&1
178 if test "$verbose" = "t"
179 then
180 exec 4>&2 3>&1
181 else
182 exec 4>/dev/null 3>/dev/null
183 fi
184
185 test_failure=0
186 test_count=0
187 test_fixed=0
188 test_broken=0
189 test_success=0
190
191 test_external_has_tap=0
192
193 die () {
194 code=$?
195 if test -n "$GIT_EXIT_OK"
196 then
197 exit $code
198 else
199 echo >&5 "FATAL: Unexpected exit with code $code"
200 exit 1
201 fi
202 }
203
204 GIT_EXIT_OK=
205 trap 'die' EXIT
206
207 # The semantics of the editor variables are that of invoking
208 # sh -c "$EDITOR \"$@\"" files ...
209 #
210 # If our trash directory contains shell metacharacters, they will be
211 # interpreted if we just set $EDITOR directly, so do a little dance with
212 # environment variables to work around this.
213 #
214 # In particular, quoting isn't enough, as the path may contain the same quote
215 # that we're using.
216 test_set_editor () {
217 FAKE_EDITOR="$1"
218 export FAKE_EDITOR
219 EDITOR='"$FAKE_EDITOR"'
220 export EDITOR
221 }
222
223 test_decode_color () {
224 awk '
225 function name(n) {
226 if (n == 0) return "RESET";
227 if (n == 1) return "BOLD";
228 if (n == 30) return "BLACK";
229 if (n == 31) return "RED";
230 if (n == 32) return "GREEN";
231 if (n == 33) return "YELLOW";
232 if (n == 34) return "BLUE";
233 if (n == 35) return "MAGENTA";
234 if (n == 36) return "CYAN";
235 if (n == 37) return "WHITE";
236 if (n == 40) return "BLACK";
237 if (n == 41) return "BRED";
238 if (n == 42) return "BGREEN";
239 if (n == 43) return "BYELLOW";
240 if (n == 44) return "BBLUE";
241 if (n == 45) return "BMAGENTA";
242 if (n == 46) return "BCYAN";
243 if (n == 47) return "BWHITE";
244 }
245 {
246 while (match($0, /\033\[[0-9;]*m/) != 0) {
247 printf "%s<", substr($0, 1, RSTART-1);
248 codes = substr($0, RSTART+2, RLENGTH-3);
249 if (length(codes) == 0)
250 printf "%s", name(0)
251 else {
252 n = split(codes, ary, ";");
253 sep = "";
254 for (i = 1; i <= n; i++) {
255 printf "%s%s", sep, name(ary[i]);
256 sep = ";"
257 }
258 }
259 printf ">";
260 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
261 }
262 print
263 }
264 '
265 }
266
267 nul_to_q () {
268 perl -pe 'y/\000/Q/'
269 }
270
271 q_to_nul () {
272 perl -pe 'y/Q/\000/'
273 }
274
275 q_to_cr () {
276 tr Q '\015'
277 }
278
279 q_to_tab () {
280 tr Q '\011'
281 }
282
283 append_cr () {
284 sed -e 's/$/Q/' | tr Q '\015'
285 }
286
287 remove_cr () {
288 tr '\015' Q | sed -e 's/Q$//'
289 }
290
291 # In some bourne shell implementations, the "unset" builtin returns
292 # nonzero status when a variable to be unset was not set in the first
293 # place.
294 #
295 # Use sane_unset when that should not be considered an error.
296
297 sane_unset () {
298 unset "$@"
299 return 0
300 }
301
302 test_tick () {
303 if test -z "${test_tick+set}"
304 then
305 test_tick=1112911993
306 else
307 test_tick=$(($test_tick + 60))
308 fi
309 GIT_COMMITTER_DATE="$test_tick -0700"
310 GIT_AUTHOR_DATE="$test_tick -0700"
311 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
312 }
313
314 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
315 #
316 # This will commit a file with the given contents and the given commit
317 # message. It will also add a tag with <message> as name.
318 #
319 # Both <file> and <contents> default to <message>.
320
321 test_commit () {
322 file=${2:-"$1.t"}
323 echo "${3-$1}" > "$file" &&
324 git add "$file" &&
325 test_tick &&
326 git commit -m "$1" &&
327 git tag "$1"
328 }
329
330 # Call test_merge with the arguments "<message> <commit>", where <commit>
331 # can be a tag pointing to the commit-to-merge.
332
333 test_merge () {
334 test_tick &&
335 git merge -m "$1" "$2" &&
336 git tag "$1"
337 }
338
339 # This function helps systems where core.filemode=false is set.
340 # Use it instead of plain 'chmod +x' to set or unset the executable bit
341 # of a file in the working directory and add it to the index.
342
343 test_chmod () {
344 chmod "$@" &&
345 git update-index --add "--chmod=$@"
346 }
347
348 # Use test_set_prereq to tell that a particular prerequisite is available.
349 # The prerequisite can later be checked for in two ways:
350 #
351 # - Explicitly using test_have_prereq.
352 #
353 # - Implicitly by specifying the prerequisite tag in the calls to
354 # test_expect_{success,failure,code}.
355 #
356 # The single parameter is the prerequisite tag (a simple word, in all
357 # capital letters by convention).
358
359 test_set_prereq () {
360 satisfied="$satisfied$1 "
361 }
362 satisfied=" "
363
364 test_have_prereq () {
365 # prerequisites can be concatenated with ','
366 save_IFS=$IFS
367 IFS=,
368 set -- $*
369 IFS=$save_IFS
370
371 total_prereq=0
372 ok_prereq=0
373 missing_prereq=
374
375 for prerequisite
376 do
377 total_prereq=$(($total_prereq + 1))
378 case $satisfied in
379 *" $prerequisite "*)
380 ok_prereq=$(($ok_prereq + 1))
381 ;;
382 *)
383 # Keep a list of missing prerequisites
384 if test -z "$missing_prereq"
385 then
386 missing_prereq=$prerequisite
387 else
388 missing_prereq="$prerequisite,$missing_prereq"
389 fi
390 esac
391 done
392
393 test $total_prereq = $ok_prereq
394 }
395
396 test_declared_prereq () {
397 case ",$test_prereq," in
398 *,$1,*)
399 return 0
400 ;;
401 esac
402 return 1
403 }
404
405 # You are not expected to call test_ok_ and test_failure_ directly, use
406 # the text_expect_* functions instead.
407
408 test_ok_ () {
409 test_success=$(($test_success + 1))
410 say_color "" "ok $test_count - $@"
411 }
412
413 test_failure_ () {
414 test_failure=$(($test_failure + 1))
415 say_color error "not ok - $test_count $1"
416 shift
417 echo "$@" | sed -e 's/^/# /'
418 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
419 }
420
421 test_known_broken_ok_ () {
422 test_fixed=$(($test_fixed+1))
423 say_color "" "ok $test_count - $@ # TODO known breakage"
424 }
425
426 test_known_broken_failure_ () {
427 test_broken=$(($test_broken+1))
428 say_color skip "not ok $test_count - $@ # TODO known breakage"
429 }
430
431 test_debug () {
432 test "$debug" = "" || eval "$1"
433 }
434
435 test_run_ () {
436 test_cleanup=:
437 eval >&3 2>&4 "$1"
438 eval_ret=$?
439 eval >&3 2>&4 "$test_cleanup"
440 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
441 echo ""
442 fi
443 return 0
444 }
445
446 test_skip () {
447 test_count=$(($test_count+1))
448 to_skip=
449 for skp in $GIT_SKIP_TESTS
450 do
451 case $this_test.$test_count in
452 $skp)
453 to_skip=t
454 break
455 esac
456 done
457 if test -z "$to_skip" && test -n "$test_prereq" &&
458 ! test_have_prereq "$test_prereq"
459 then
460 to_skip=t
461 fi
462 case "$to_skip" in
463 t)
464 of_prereq=
465 if test "$missing_prereq" != "$test_prereq"
466 then
467 of_prereq=" of $test_prereq"
468 fi
469
470 say_color skip >&3 "skipping test: $@"
471 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
472 : true
473 ;;
474 *)
475 false
476 ;;
477 esac
478 }
479
480 test_expect_failure () {
481 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
482 test "$#" = 2 ||
483 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
484 export test_prereq
485 if ! test_skip "$@"
486 then
487 say >&3 "checking known breakage: $2"
488 test_run_ "$2"
489 if [ "$?" = 0 -a "$eval_ret" = 0 ]
490 then
491 test_known_broken_ok_ "$1"
492 else
493 test_known_broken_failure_ "$1"
494 fi
495 fi
496 echo >&3 ""
497 }
498
499 test_expect_success () {
500 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
501 test "$#" = 2 ||
502 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
503 export test_prereq
504 if ! test_skip "$@"
505 then
506 say >&3 "expecting success: $2"
507 test_run_ "$2"
508 if [ "$?" = 0 -a "$eval_ret" = 0 ]
509 then
510 test_ok_ "$1"
511 else
512 test_failure_ "$@"
513 fi
514 fi
515 echo >&3 ""
516 }
517
518 # test_external runs external test scripts that provide continuous
519 # test output about their progress, and succeeds/fails on
520 # zero/non-zero exit code. It outputs the test output on stdout even
521 # in non-verbose mode, and announces the external script with "# run
522 # <n>: ..." before running it. When providing relative paths, keep in
523 # mind that all scripts run in "trash directory".
524 # Usage: test_external description command arguments...
525 # Example: test_external 'Perl API' perl ../path/to/test.pl
526 test_external () {
527 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
528 test "$#" = 3 ||
529 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
530 descr="$1"
531 shift
532 export test_prereq
533 if ! test_skip "$descr" "$@"
534 then
535 # Announce the script to reduce confusion about the
536 # test output that follows.
537 say_color "" "# run $test_count: $descr ($*)"
538 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
539 # to be able to use them in script
540 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
541 # Run command; redirect its stderr to &4 as in
542 # test_run_, but keep its stdout on our stdout even in
543 # non-verbose mode.
544 "$@" 2>&4
545 if [ "$?" = 0 ]
546 then
547 if test $test_external_has_tap -eq 0; then
548 test_ok_ "$descr"
549 else
550 say_color "" "# test_external test $descr was ok"
551 test_success=$(($test_success + 1))
552 fi
553 else
554 if test $test_external_has_tap -eq 0; then
555 test_failure_ "$descr" "$@"
556 else
557 say_color error "# test_external test $descr failed: $@"
558 test_failure=$(($test_failure + 1))
559 fi
560 fi
561 fi
562 }
563
564 # Like test_external, but in addition tests that the command generated
565 # no output on stderr.
566 test_external_without_stderr () {
567 # The temporary file has no (and must have no) security
568 # implications.
569 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
570 stderr="$tmp/git-external-stderr.$$.tmp"
571 test_external "$@" 4> "$stderr"
572 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
573 descr="no stderr: $1"
574 shift
575 say >&3 "# expecting no stderr from previous command"
576 if [ ! -s "$stderr" ]; then
577 rm "$stderr"
578
579 if test $test_external_has_tap -eq 0; then
580 test_ok_ "$descr"
581 else
582 say_color "" "# test_external_without_stderr test $descr was ok"
583 test_success=$(($test_success + 1))
584 fi
585 else
586 if [ "$verbose" = t ]; then
587 output=`echo; echo "# Stderr is:"; cat "$stderr"`
588 else
589 output=
590 fi
591 # rm first in case test_failure exits.
592 rm "$stderr"
593 if test $test_external_has_tap -eq 0; then
594 test_failure_ "$descr" "$@" "$output"
595 else
596 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
597 test_failure=$(($test_failure + 1))
598 fi
599 fi
600 }
601
602 # debugging-friendly alternatives to "test [-f|-d|-e]"
603 # The commands test the existence or non-existence of $1. $2 can be
604 # given to provide a more precise diagnosis.
605 test_path_is_file () {
606 if ! [ -f "$1" ]
607 then
608 echo "File $1 doesn't exist. $*"
609 false
610 fi
611 }
612
613 test_path_is_dir () {
614 if ! [ -d "$1" ]
615 then
616 echo "Directory $1 doesn't exist. $*"
617 false
618 fi
619 }
620
621 test_path_is_missing () {
622 if [ -e "$1" ]
623 then
624 echo "Path exists:"
625 ls -ld "$1"
626 if [ $# -ge 1 ]; then
627 echo "$*"
628 fi
629 false
630 fi
631 }
632
633 # test_line_count checks that a file has the number of lines it
634 # ought to. For example:
635 #
636 # test_expect_success 'produce exactly one line of output' '
637 # do something >output &&
638 # test_line_count = 1 output
639 # '
640 #
641 # is like "test $(wc -l <output) = 1" except that it passes the
642 # output through when the number of lines is wrong.
643
644 test_line_count () {
645 if test $# != 3
646 then
647 error "bug in the test script: not 3 parameters to test_line_count"
648 elif ! test $(wc -l <"$3") "$1" "$2"
649 then
650 echo "test_line_count: line count for $3 !$1 $2"
651 cat "$3"
652 return 1
653 fi
654 }
655
656 # This is not among top-level (test_expect_success | test_expect_failure)
657 # but is a prefix that can be used in the test script, like:
658 #
659 # test_expect_success 'complain and die' '
660 # do something &&
661 # do something else &&
662 # test_must_fail git checkout ../outerspace
663 # '
664 #
665 # Writing this as "! git checkout ../outerspace" is wrong, because
666 # the failure could be due to a segv. We want a controlled failure.
667
668 test_must_fail () {
669 "$@"
670 exit_code=$?
671 if test $exit_code = 0; then
672 echo >&2 "test_must_fail: command succeeded: $*"
673 return 1
674 elif test $exit_code -gt 129 -a $exit_code -le 192; then
675 echo >&2 "test_must_fail: died by signal: $*"
676 return 1
677 elif test $exit_code = 127; then
678 echo >&2 "test_must_fail: command not found: $*"
679 return 1
680 fi
681 return 0
682 }
683
684 # Similar to test_must_fail, but tolerates success, too. This is
685 # meant to be used in contexts like:
686 #
687 # test_expect_success 'some command works without configuration' '
688 # test_might_fail git config --unset all.configuration &&
689 # do something
690 # '
691 #
692 # Writing "git config --unset all.configuration || :" would be wrong,
693 # because we want to notice if it fails due to segv.
694
695 test_might_fail () {
696 "$@"
697 exit_code=$?
698 if test $exit_code -gt 129 -a $exit_code -le 192; then
699 echo >&2 "test_might_fail: died by signal: $*"
700 return 1
701 elif test $exit_code = 127; then
702 echo >&2 "test_might_fail: command not found: $*"
703 return 1
704 fi
705 return 0
706 }
707
708 # Similar to test_must_fail and test_might_fail, but check that a
709 # given command exited with a given exit code. Meant to be used as:
710 #
711 # test_expect_success 'Merge with d/f conflicts' '
712 # test_expect_code 1 git merge "merge msg" B master
713 # '
714
715 test_expect_code () {
716 want_code=$1
717 shift
718 "$@"
719 exit_code=$?
720 if test $exit_code = $want_code
721 then
722 echo >&2 "test_expect_code: command exited with $exit_code: $*"
723 return 0
724 else
725 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
726 return 1
727 fi
728 }
729
730 # test_cmp is a helper function to compare actual and expected output.
731 # You can use it like:
732 #
733 # test_expect_success 'foo works' '
734 # echo expected >expected &&
735 # foo >actual &&
736 # test_cmp expected actual
737 # '
738 #
739 # This could be written as either "cmp" or "diff -u", but:
740 # - cmp's output is not nearly as easy to read as diff -u
741 # - not all diff versions understand "-u"
742
743 test_cmp() {
744 $GIT_TEST_CMP "$@"
745 }
746
747 # This function can be used to schedule some commands to be run
748 # unconditionally at the end of the test to restore sanity:
749 #
750 # test_expect_success 'test core.capslock' '
751 # git config core.capslock true &&
752 # test_when_finished "git config --unset core.capslock" &&
753 # hello world
754 # '
755 #
756 # That would be roughly equivalent to
757 #
758 # test_expect_success 'test core.capslock' '
759 # git config core.capslock true &&
760 # hello world
761 # git config --unset core.capslock
762 # '
763 #
764 # except that the greeting and config --unset must both succeed for
765 # the test to pass.
766
767 test_when_finished () {
768 test_cleanup="{ $*
769 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
770 }
771
772 # Most tests can use the created repository, but some may need to create more.
773 # Usage: test_create_repo <directory>
774 test_create_repo () {
775 test "$#" = 1 ||
776 error "bug in the test script: not 1 parameter to test-create-repo"
777 repo="$1"
778 mkdir -p "$repo"
779 (
780 cd "$repo" || error "Cannot setup test environment"
781 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
782 error "cannot run git init -- have you built things yet?"
783 mv .git/hooks .git/hooks-disabled
784 ) || exit
785 }
786
787 test_done () {
788 GIT_EXIT_OK=t
789
790 if test -z "$HARNESS_ACTIVE"; then
791 test_results_dir="$TEST_DIRECTORY/test-results"
792 mkdir -p "$test_results_dir"
793 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
794
795 echo "total $test_count" >> $test_results_path
796 echo "success $test_success" >> $test_results_path
797 echo "fixed $test_fixed" >> $test_results_path
798 echo "broken $test_broken" >> $test_results_path
799 echo "failed $test_failure" >> $test_results_path
800 echo "" >> $test_results_path
801 fi
802
803 if test "$test_fixed" != 0
804 then
805 say_color pass "# fixed $test_fixed known breakage(s)"
806 fi
807 if test "$test_broken" != 0
808 then
809 say_color error "# still have $test_broken known breakage(s)"
810 msg="remaining $(($test_count-$test_broken)) test(s)"
811 else
812 msg="$test_count test(s)"
813 fi
814 case "$test_failure" in
815 0)
816 # Maybe print SKIP message
817 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
818
819 if test $test_external_has_tap -eq 0; then
820 say_color pass "# passed all $msg"
821 say "1..$test_count$skip_all"
822 fi
823
824 test -d "$remove_trash" &&
825 cd "$(dirname "$remove_trash")" &&
826 rm -rf "$(basename "$remove_trash")"
827
828 exit 0 ;;
829
830 *)
831 if test $test_external_has_tap -eq 0; then
832 say_color error "# failed $test_failure among $msg"
833 say "1..$test_count"
834 fi
835
836 exit 1 ;;
837
838 esac
839 }
840
841 # Test the binaries we have just built. The tests are kept in
842 # t/ subdirectory and are run in 'trash directory' subdirectory.
843 if test -z "$TEST_DIRECTORY"
844 then
845 # We allow tests to override this, in case they want to run tests
846 # outside of t/, e.g. for running tests on the test library
847 # itself.
848 TEST_DIRECTORY=$(pwd)
849 fi
850 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
851
852 if test -n "$valgrind"
853 then
854 make_symlink () {
855 test -h "$2" &&
856 test "$1" = "$(readlink "$2")" || {
857 # be super paranoid
858 if mkdir "$2".lock
859 then
860 rm -f "$2" &&
861 ln -s "$1" "$2" &&
862 rm -r "$2".lock
863 else
864 while test -d "$2".lock
865 do
866 say "Waiting for lock on $2."
867 sleep 1
868 done
869 fi
870 }
871 }
872
873 make_valgrind_symlink () {
874 # handle only executables
875 test -x "$1" || return
876
877 base=$(basename "$1")
878 symlink_target=$GIT_BUILD_DIR/$base
879 # do not override scripts
880 if test -x "$symlink_target" &&
881 test ! -d "$symlink_target" &&
882 test "#!" != "$(head -c 2 < "$symlink_target")"
883 then
884 symlink_target=../valgrind.sh
885 fi
886 case "$base" in
887 *.sh|*.perl)
888 symlink_target=../unprocessed-script
889 esac
890 # create the link, or replace it if it is out of date
891 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
892 }
893
894 # override all git executables in TEST_DIRECTORY/..
895 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
896 mkdir -p "$GIT_VALGRIND"/bin
897 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
898 do
899 make_valgrind_symlink $file
900 done
901 OLDIFS=$IFS
902 IFS=:
903 for path in $PATH
904 do
905 ls "$path"/git-* 2> /dev/null |
906 while read file
907 do
908 make_valgrind_symlink "$file"
909 done
910 done
911 IFS=$OLDIFS
912 PATH=$GIT_VALGRIND/bin:$PATH
913 GIT_EXEC_PATH=$GIT_VALGRIND/bin
914 export GIT_VALGRIND
915 elif test -n "$GIT_TEST_INSTALLED" ; then
916 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
917 error "Cannot run git from $GIT_TEST_INSTALLED."
918 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
919 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
920 else # normal case, use ../bin-wrappers only unless $with_dashes:
921 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
922 if ! test -x "$git_bin_dir/git" ; then
923 if test -z "$with_dashes" ; then
924 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
925 fi
926 with_dashes=t
927 fi
928 PATH="$git_bin_dir:$PATH"
929 GIT_EXEC_PATH=$GIT_BUILD_DIR
930 if test -n "$with_dashes" ; then
931 PATH="$GIT_BUILD_DIR:$PATH"
932 fi
933 fi
934 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
935 unset GIT_CONFIG
936 GIT_CONFIG_NOSYSTEM=1
937 GIT_ATTR_NOSYSTEM=1
938 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
939
940 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
941
942 if test -z "$GIT_TEST_CMP"
943 then
944 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
945 then
946 GIT_TEST_CMP="$DIFF -c"
947 else
948 GIT_TEST_CMP="$DIFF -u"
949 fi
950 fi
951
952 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
953 export GITPERLLIB
954 test -d "$GIT_BUILD_DIR"/templates/blt || {
955 error "You haven't built things yet, have you?"
956 }
957
958 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
959 then
960 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
961 export GITPYTHONLIB
962 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
963 error "You haven't built git_remote_helpers yet, have you?"
964 }
965 fi
966
967 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
968 echo >&2 'You need to build test-chmtime:'
969 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
970 exit 1
971 fi
972
973 # Test repository
974 test="trash directory.$(basename "$0" .sh)"
975 test -n "$root" && test="$root/$test"
976 case "$test" in
977 /*) TRASH_DIRECTORY="$test" ;;
978 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
979 esac
980 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
981 rm -fr "$test" || {
982 GIT_EXIT_OK=t
983 echo >&5 "FATAL: Cannot prepare test area"
984 exit 1
985 }
986
987 test_create_repo "$test"
988 # Use -P to resolve symlinks in our working directory so that the cwd
989 # in subprocesses like git equals our $PWD (for pathname comparisons).
990 cd -P "$test" || exit 1
991
992 HOME=$(pwd)
993 export HOME
994
995 this_test=${0##*/}
996 this_test=${this_test%%-*}
997 for skp in $GIT_SKIP_TESTS
998 do
999 case "$this_test" in
1000 $skp)
1001 say_color skip >&3 "skipping test $this_test altogether"
1002 skip_all="skip all tests in $this_test"
1003 test_done
1004 esac
1005 done
1006
1007 # Provide an implementation of the 'yes' utility
1008 yes () {
1009 if test $# = 0
1010 then
1011 y=y
1012 else
1013 y="$*"
1014 fi
1015
1016 while echo "$y"
1017 do
1018 :
1019 done
1020 }
1021
1022 # Fix some commands on Windows
1023 case $(uname -s) in
1024 *MINGW*)
1025 # Windows has its own (incompatible) sort and find
1026 sort () {
1027 /usr/bin/sort "$@"
1028 }
1029 find () {
1030 /usr/bin/find "$@"
1031 }
1032 sum () {
1033 md5sum "$@"
1034 }
1035 # git sees Windows-style pwd
1036 pwd () {
1037 builtin pwd -W
1038 }
1039 # no POSIX permissions
1040 # backslashes in pathspec are converted to '/'
1041 # exec does not inherit the PID
1042 test_set_prereq MINGW
1043 test_set_prereq SED_STRIPS_CR
1044 ;;
1045 *CYGWIN*)
1046 test_set_prereq POSIXPERM
1047 test_set_prereq EXECKEEPSPID
1048 test_set_prereq NOT_MINGW
1049 test_set_prereq SED_STRIPS_CR
1050 ;;
1051 *)
1052 test_set_prereq POSIXPERM
1053 test_set_prereq BSLASHPSPEC
1054 test_set_prereq EXECKEEPSPID
1055 test_set_prereq NOT_MINGW
1056 ;;
1057 esac
1058
1059 test -z "$NO_PERL" && test_set_prereq PERL
1060 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1061
1062 # Can we rely on git's output in the C locale?
1063 if test -n "$GETTEXT_POISON"
1064 then
1065 GIT_GETTEXT_POISON=YesPlease
1066 export GIT_GETTEXT_POISON
1067 else
1068 test_set_prereq C_LOCALE_OUTPUT
1069 fi
1070
1071 # test whether the filesystem supports symbolic links
1072 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1073 rm -f y
1074
1075 # When the tests are run as root, permission tests will report that
1076 # things are writable when they shouldn't be.
1077 test -w / || test_set_prereq SANITY